LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY IRS_SEL IS
	PORT
	(
		IOWN,reset			: IN	STD_LOGIC;
		IRS_RS				: IN	STD_LOGIC;
		DATA_IN				: IN	STD_LOGIC_VECTOR(1 downto 0);
		IR_S				: IN	STD_LOGIC_VECTOR(1 downto 0);
		IRS_NUM				: OUT	STD_LOGIC_VECTOR(2 downto 0);
		IR_OUT				: OUT 	STD_LOGIC
	);
	
END IRS_SEL;
ARCHITECTURE RTL OF IRS_SEL IS
SIGNAL IRS_SELECT : std_logic_VECTOR(1 downto 0);
begin
	process(IOWN)
	begin
		if(reset = '1') then	
			IRS_SELECT <= "00";			
		elsif (IOWN'EVENT and IOWN = '0') then	
			if(IRS_RS = '1') then	
				IRS_SELECT <= DATA_IN;
			else
				IRS_SELECT <= IRS_SELECT;
			end if;
		end if;	
	end process;
	process(IRS_SELECT)
	begin
		case IRS_SELECT is
			when "01" => IR_OUT <= not IR_S(0);
						IRS_NUM(1) <= '1';
			when "10" => IR_OUT <= not IR_S(1);
						IRS_NUM(2) <= '1';
			when others => IR_OUT <= '0';
		end case;
	end process;
 IRS_NUM(0)<= '0';
 END RTL;

