LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY IRS_SEL2 IS
	PORT
	(
		IOWN,reset			: IN	STD_LOGIC;
		IRS_RS				: IN	STD_LOGIC;
		DATA_IN				: IN	STD_LOGIC_vector(1 downto 0);
		IR_S				: IN	STD_LOGIC_VECTOR(1 downto 0);
		IRS_NUM				: OUT	STD_LOGIC_vector(2 downto 0);
		IR_OUT				: OUT 	STD_LOGIC
	);
	
END IRS_SEL2;
ARCHITECTURE RTL OF IRS_SEL2 IS
SIGNAL IRS_SELECT : std_logic_vector(1 downto 0);
begin
	process(IOWN)
	begin
		if(reset = '1') then	
			IRS_SELECT <= "00";	
--  IOWN ga 0-> 1 ni nattara 	
		elsif (IOWN'EVENT and IOWN = '1') then	
			if(IRS_RS = '1') then	
				IRS_SELECT <= DATA_IN;
			else
				IRS_SELECT <= IRS_SELECT;
			end if;
		end if;	
	end process;
	process(IRS_SELECT,IR_S)
	begin
		case IRS_SELECT is
			when "01" => IR_OUT <= IR_S(0);
						 IRS_NUM <= "010";	
			when "10" => IR_OUT <= IR_S(1);
						 IRS_NUM <= "100";
			when others => IR_OUT <= '0';
		end case;
	end process;
END RTL;

