LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY IRSOUT_SEL IS
	PORT
	(
		IRS 				: IN	STD_LOGIC_VECTOR(11 DOWNTO 0);
		FLAG				: IN	STD_LOGIC;
		SEL					: IN	STD_LOGIC_VECTOR(2 downto 0);
		B_IOWN,B_IORN		: IN	STD_LOGIC;
		IRS_ADD,IRS_RS		: IN	STD_LOGIC;
		B_RESET				: IN	STD_LOGIC;
		B_CLK				: IN	STD_LOGIC;
		IRS_OUT				: OUT 	STD_LOGIC_VECTOR(15 DOWNTO 0)
	);
END IRSOUT_SEL;

ARCHITECTURE RTL OF IRSOUT_SEL IS
	SIGNAL	IRS_DUM	: STD_LOGIC_VECTOR(15 DOWNTO 0);
BEGIN
	PROCESS (B_CLK,B_RESET) begin
		if(B_RESET='1')then
				IRS_DUM <= "0000000000000000";
		elsif(B_CLK'event and B_CLK='1')then
			if(B_IOWN='0' and IRS_RS='1')then
				IRS_DUM <="0000000000000000";
			elsif(B_IORN='0' and IRS_ADD='1')then
					IRS_DUM(15) <= FLAG;
					IRS_DUM(14 downto 12) <= SEL;
					IRS_DUM(11 downto 0) <= IRS(11 downto 0);
			end if;
		end if;
	END PROCESS;
IRS_OUT <= IRS_DUM;
END RTL;

