LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY selecter IS
	PORT
	(
		IORN		: IN	STD_LOGIC;
		LCD_ADD		: IN	STD_LOGIC;
		LCD_DATA	: IN	STD_LOGIC_VECTOR(7 downto 0);
		MPC_ADD		: IN	STD_LOGIC;
		MPC_DATA	: IN	STD_LOGIC_VECTOR(7 downto 0);
		RE_ADD		: IN	STD_LOGIC;
		RE_DATA		: IN	STD_LOGIC_VECTOR(15 downto 0);
		TP_ADD		: IN	STD_LOGIC;
		TP_DATA		: IN	STD_LOGIC_VECTOR(15 downto 0);
		IRS_ADD		: IN	STD_LOGIC;
		IRS_DATA	: IN	STD_LOGIC_VECTOR(15 downto 0);
		DATA_OUT	: OUT 	STD_LOGIC_VECTOR(15 downto 0)
	);
END selecter;

ARCHITECTURE RTL OF selecter IS
BEGIN
	PROCESS (IORN
			,LCD_ADD,LCD_DATA
			,MPC_ADD,MPC_DATA
			,RE_ADD,RE_DATA
			,TP_ADD,TP_DATA
			,IRS_ADD,IRS_DATA)
	BEGIN

			if(LCD_ADD = '1' and IORN='0')then
				DATA_OUT(7 downto 0) <= LCD_DATA;
				DATA_OUT(15 downto 8) <= "00000000";
			elsif( MPC_ADD = '1' and IORN='0')then
				DATA_OUT(7 downto 0) <= MPC_DATA;
				DATA_OUT(15 downto 8) <= "00000000";
			elsif(RE_ADD = '1'  and IORN='0')then
				DATA_OUT <= RE_DATA;
			elsif(TP_ADD = '1'  and IORN='0')then
				DATA_OUT <= TP_DATA;
			elsif(IRS_ADD = '1' and IORN='0')then
				DATA_OUT <= IRS_DATA;
			else
				DATA_OUT <= "0000000000000000";

 		END IF;
	END PROCESS;	
END RTL;

