LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY TLP_LATCH IS
	PORT
	(
		TSIN				: IN	STD_LOGIC;
		LSIN				: IN	STD_LOGIC_VECTOR(3 DOWNTO 0);
		RESET,PO_IN			: IN	STD_LOGIC;
		TLP_ADD1			: IN	STD_LOGIC;
		B_IOWN,B_IORN		: IN	STD_LOGIC;
		B_RESET				: IN	STD_LOGIC;
		B_CLK				: IN	STD_LOGIC;
		TLPOUT				: OUT 	STD_LOGIC_VECTOR(15 DOWNTO 0)
	);
END TLP_LATCH;

ARCHITECTURE RTL OF TLP_LATCH IS
	SIGNAL	TLPDUM	: STD_LOGIC_VECTOR(15 DOWNTO 0);
BEGIN
	PROCESS (B_CLK,B_RESET) begin
		if(B_RESET='1')then
			TLPDUM <= "0000000000000000";
		elsif(B_CLK'event and B_CLK='1')then
			if(B_IOWN='0' and TLP_ADD1='1' and RESET='1')then
				TLPDUM <="0000000000000000";
			elsif(B_IORN='1')then
				TLPDUM(3 downto 0) <= not LSIN;
				TLPDUM(7 downto 4) <= "0000";
				TLPDUM(8) <= TSIN;
				TLPDUM(11 downto 9) <= "000";
				TLPDUM(15) <= PO_IN;
				TLPDUM(14 downto 12) <= "000";
			end if;
		end if;
	END PROCESS;
TLPOUT <= TLPDUM;
END RTL;

